<template>
    <v-container fluid>


        <v-card max-width="1200" class="ma-auto">

            <v-alert v-if="err != ''" dense text type="error" max-width="800" class="mx-auto my-2 pa-2">
                {{err}}
            </v-alert>
            <v-alert v-if="ok != ''" dense text type="success" max-width="800" class="mx-auto my-2 pa-2">
                {{success}}
            </v-alert>

            <v-list-item three-line>
                <v-list-item-content>
                    <div class="overline mb-4" :style="{color: subContractor.light.color}">
                        {{subContractor.light.color}}
                    </div>
                    <v-list-item-title class="headline mb-1">
                        {{subContractor.light.name}}
                    </v-list-item-title>
                    <v-list-item-subtitle>{{subContractor.light.id}}</v-list-item-subtitle>
                </v-list-item-content>

                <v-list-item-avatar tile size="80">
                    <img :src="subContractor.light.logo"/>
                </v-list-item-avatar>
            </v-list-item>
            <v-divider/>
            <v-list three-line>
                <template v-for="(w, i) in workers">
                    <v-list-item :key="w.id">
                        <v-list-item-avatar>
                            <v-img v-if="w.image != ''" :src="w.image" alt="profile"/>
                            <span v-else class="white---text headline">{{w.name.CapitalizeWords().split(' ').Map(x=>x.Take())}}</span>
                        </v-list-item-avatar>
                        <v-list-item-content>
                            <v-list-item-title>{{w.name}}</v-list-item-title>
                            <v-list-item-subtitle> {{w.id}}• {{w.tag}}</v-list-item-subtitle>
                            <v-list-item-subtitle>
                                <v-chip :key="t" class="ma-1" color='primary' small v-for="t in w.trade">
                                    {{t}}
                                </v-chip>
                            </v-list-item-subtitle>
                        </v-list-item-content>
                        <v-list-item-action>
                            <DeleteIcon
                                    title="Are you sure you want to this worker?"
                                    :text="`Are you sure you want to delete worker ${w.name} with ID
                                    ${w.id}? The tag ${w.tag} will remain, and not be deleted. This cannot be undone.`"
                                    tooltip="Delete Worker"
                                    :id="w.id"
                                    :back-f="()=>{}"
                                    :delete-f="DeleteWorker"
                            />
                        </v-list-item-action>
                    </v-list-item>
                </template>
            </v-list>
            <v-tooltip bottom>
                <template #activator="{ on, attrs }">
                    <v-btn color="pink" dark absolute bottom right fab v-bind="attrs" v-on="on"
                           :to="`/sub/${subContractor.light.id}/worker/create`">
                        <v-icon>mdi-plus</v-icon>
                    </v-btn>
                </template>
                <span>Create Worker-Tag Pair</span>
            </v-tooltip>
        </v-card>
    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component} from 'vue-property-decorator';
    import {Mixins} from "vue-mixin-decorator";
    import {Validable} from "../../mixins/Validable";
    import {Initializable} from "../../mixins/Initializable";
    import {coreApi} from "../../init";
    import {SubContractorResponse} from "../../../../classLibrary/core/subContractorResponse";
    import {SubContractorLightResponse} from "../../../../classLibrary/core/subContractorLightResponse";
    import {WorkerResponse} from "../../../../classLibrary/core/workerResponse";
    import DeleteIcon from "../../components/DeleteIcon.vue";

    interface WorkerInfo {
        name: string;
        trade: string;
        image: string;
        id: string;
        tag: string;
    }

    interface SubContractorMixin extends Validable, Initializable {
    }

    @Component({
        components: {DeleteIcon}
    })
    export default class SubContractor extends Mixins<SubContractorMixin>(Validable, Initializable) {

        subId: string = '';
        subContractor: SubContractorResponse = new SubContractorResponse(
            new SubContractorLightResponse("", "", "", "", {}),
            []
        )
        workers: WorkerInfo[] = [];

        async DeleteWorker(id: string) {
            const r = await coreApi.Delete(`Worker/${this.subId}/${id}`);
            if (r) {
                this.ok = "Successfully deleted worker";
                await this.update();
            } else {
                this.err = "Failed to delete worker";
            }
        }

        async update() {
            this.subId = this.$route.params.id;
            const r = await coreApi.Get<SubContractorResponse>(`SubContractor/${this.subId}`);
            if (!r.success) await this.$router.push("not found")
            else {
                this.subContractor = r.Ok!;
                this.workers = await Promise.all(this.subContractor.workers
                    .Map(async x => {
                        const r1 = await coreApi.Get<WorkerResponse>(`Worker/${this.subId}/${x.id}`);
                        if (r1.Ok) {
                            return {
                                name: x.name,
                                tag: r1.Ok!.tag.macAddress,
                                trade: x.trade,
                                image: x.image,
                                id: x.id,
                            } as WorkerInfo
                        } else {
                            (this.$parent as any).error = r!.error!;
                            return {
                                name: x.name,
                                tag: "",
                                trade: x.trade,
                                image: x.image,
                                id: x.id,
                            } as WorkerInfo
                        }
                    }));
            }
        }


        async init() {
            await this.update();
        }

        async mountInit() {

        }

    }
</script>
